﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;
using Infragistics.Controls.Grids.Primitives;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            // Original-Source from IG-Sample: 
            //this.DataContext = CreateTable(4, 10).DefaultView;

            CreateGridLayout(grid, 4);
            grid.ItemsSource = CreateTable(4, 5).DefaultView;
        }

        private bool CreateGridLayout(XamGrid gridTable, int columns)
        {
            // Create the Grid-Layout
            gridTable.Columns.Clear();
            gridTable.ItemsSource = null;
            gridTable.HeaderRowHeight = RowHeight.Dynamic;

            for (int i = 0; i < columns; i++)
            {
                CheckBoxColumn chckcol = new CheckBoxColumn();
                chckcol.Key = "col" + (i + 1).ToString();
                chckcol.HeaderText = "Col" + (i+1).ToString();

                chckcol.EditorDisplayBehavior = EditorDisplayBehaviors.Always;
                gridTable.Columns.Add(chckcol);
            }

            return true;
        }

        public DataTable CreateTable(int columns, int rows)
        {
            DataTable d = new DataTable();
            // Original-Source from IG-Sample: 
            //Random r = new Random();

            for (int i = 0; i < columns; i++)
            {
                // Original-Source from IG-Sample: 
                //d.Columns.Add(new DataColumn("Column " + i, typeof(int)));

                d.Columns.Add(new DataColumn("col" + (i + 1).ToString()));
            }
            for (int i = 0; i < rows; i++)
            {
                DataRow row = d.NewRow();

                for (int j = 0; j < columns; j++)
                {
                    // Original-Source from IG-Sample: 
                    //row["Column " + j] = r.Next(1000 * i);
                    row[j] = false;
                }

                d.Rows.Add(row);
            }
            return d;
        }

        private void HeaderControl_PreviewMouseMove(object sender, MouseEventArgs e)
        {
            if ((sender as HeaderCellControl).Column.ColumnLayout.Columns.Where(t => (t as Column).IsSelected).Count() != 0
            && !(sender as HeaderCellControl).Column.ColumnLayout.Grid.SelectionSettings.SelectedColumns.Contains((sender as HeaderCellControl).Column)
            && e.LeftButton == MouseButtonState.Pressed
                && !Keyboard.IsKeyDown(Key.LeftCtrl))
            {
                (sender as HeaderCellControl).Column.ColumnLayout.Grid.SelectionSettings.SelectedColumns.Add((sender as HeaderCellControl).Column);
                System.Diagnostics.Trace.WriteLine("HeaderControl_PreviewMouseMove:");
                System.Diagnostics.Trace.WriteLine("  grid.SelectionSettings.SelectedColumns.Count: " + grid.SelectionSettings.SelectedColumns.Count.ToString());
                //Requirement for our Application: Selection of multiple rows in the same way it works for columns.
            }            
        }

        private void HeaderControl_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            if (!Keyboard.IsKeyDown(Key.LeftCtrl))
            {
                // Optimization from me
                grid.SelectionSettings.SelectedCells.Clear();
                grid.SelectionSettings.SelectedRows.Clear();
                grid.SelectionSettings.SelectedColumns.Clear();

                (sender as HeaderCellControl).Column.ColumnLayout.Grid.SelectionSettings.SelectedColumns.Add((sender as HeaderCellControl).Column);
                System.Diagnostics.Trace.WriteLine("HeaderControl_PreviewMouseDown:");
                System.Diagnostics.Trace.WriteLine("  grid.SelectionSettings.SelectedColumns.Count: " + grid.SelectionSettings.SelectedColumns.Count.ToString());
                //Requirement for our Application: Selection of multiple rows in the same way it works for columns.
            }            
        }

        private void XamGrid_KeyDown(object sender, KeyEventArgs e)
        {
            System.Diagnostics.Trace.WriteLine("XamGrid_KeyDown:");
            System.Diagnostics.Trace.WriteLine("  grid.SelectionSettings.SelectedCells.Count: " + grid.SelectionSettings.SelectedCells.Count.ToString());
            System.Diagnostics.Trace.WriteLine("  grid.SelectionSettings.SelectedRows.Count: " + grid.SelectionSettings.SelectedRows.Count.ToString());
            System.Diagnostics.Trace.WriteLine("  grid.SelectionSettings.SelectedColumns.Count: " + grid.SelectionSettings.SelectedColumns.Count.ToString());

            if (e.Key == Key.Space)
            {
                //Requirement for our Application: Toggle Check/Uncheck state of all CheckBoxes in the secected columns or rows
            }
        }

    }
}
